
#include "lcd.h"
#include "2048.c"

static int debounced;
static int started;
static int board[SIZE][SIZE];

/*void check_buttons()
{
    switch ((~PINA & ((1 << PA3) | (1 << PA5) | (1 << PA6) | (1 << PA7))))
    {
        case (1 << PA3):
        if (debounced == 1)
        {
            debounced = 0;
            if (started < 1)
                start();
            else if (move_stage == 0 && test(LEFT, speeds))
                begin_move(LEFT);
        }
        break;
        
        case (1 << PA6):
        if (debounced == 1)
        {
            debounced = 0;
            if (started < 1)
                start();
            else if (move_stage == 0 && test(DOWN, speeds))
                begin_move(DOWN);
        }
        break;
        
        case (1 << PA5):
        if (debounced == 1)
        {
            debounced = 0;
            if (started < 1)
                start();
            else if (move_stage == 0 && test(UP, speeds))
                begin_move(UP);
        }
        break;
        
        case (1 << PA7):
        if (debounced == 1)
        {
            debounced = 0;
            if (started < 1)
                start();
            else if (move_stage == 0 && test(RIGHT, speeds))
                begin_move(RIGHT);
        }
        break;
        
        default:
            debounced = 1;
    }
}*/

void sys_init(void)
{  
    MCUCR |= (1 << JTD); 
    MCUCR |= (1 << JTD);
}

void io_init(void)
{
    DDRA &= ~((1 << PA3) | (1 << PA4) | (1 << PA5) | (1 << PA6) | (1 << PA7));
    PORTA |= (1 << PA3) | (1 << PA4) | (1 << PA5) | (1 << PA6) | (1 << PA7);
    
	DDRA |= (1 << PA1)| (1 << PA2);
	
	DDRD &= ~(1 << PD6); 
	PORTD |= (1 << PD6);
}
int cifre(int value){
	
	int nr_cifre = 0;
	while(value != 0) {
		nr_cifre++;
		value /= 10;
	}
	return nr_cifre;
}
void draw(void)
{    
    int i, j;

    switch (started)
    {
        case 0:
            lcd_goto_xy(1, 25);
			lcd_str((char *)"Press start!");
			break;    
        case -1:
			lcd_clear();
			PORTA |= 1 << PA2;
            lcd_goto_xy(4, 25);
			lcd_str((char *)"ai castigat!");
			lcd_goto_xy(1, 50);
			lcd_str((char *)"Press restart");
			break;
        
        case -2:
			lcd_clear();
			PORTA |= 1 << PA1;
            lcd_goto_xy(4, 25);
			lcd_str((char *)"ai pierdut!");
			lcd_goto_xy(1, 50);
			lcd_str((char *)"Press restart");
			break;
        
        default:
			int offset_y = 25;
			
			for (i = 0; i < SIZE; i++)
                for (j = 0; j < SIZE; j++)
                    
					if(board[i][j] > 0){
						char *str;
						switch(cifre(board[i][j])) {
							case 2:
								str = (char*)malloc(5*sizeof(char));
								lcd_goto_xy((j*4+1), (i+1));
								lcd_str(itoa(20, str, 10));
								lcd_str((char*)" / ");
								lcd_send(board[i][j], LCD_DATA);
							case 3:
								str = (char*)malloc(5*sizeof(char));
								lcd_goto_xy((j*4+1), (i+1));
								lcd_str(itoa(20, str, 10));
								lcd_str((char*)" / ");
								lcd_send(board[i][j], LCD_DATA);
							case 4:
								str = (char*)malloc(5*sizeof(char));
								lcd_goto_xy((j*4+1), (i+1));
								lcd_str(itoa(20, str, 10));
								lcd_str((char*)" / ");
								lcd_send(board[i][j], LCD_DATA);
							default:
								str = (char*)malloc(5*sizeof(char));
								lcd_goto_xy((j*4+1), (i+1));
								lcd_str(itoa(board[i][j], str, 10));
								lcd_str((char*)" / ");
								lcd_send(board[i][j], LCD_DATA);									
						}
						
					}
			break;
    }
}

int main(void)
{
    sys_init();
	lcd_init();
	lcd_contrast(0x40);
	io_init();
	
	initBoard(board);
	
	started = 0;
    debounced = 1;
   
	draw();
	
    for ( ; ; )
    {   
        if (started == 1)
        {
            if (gameEnded(board) == 10)
                started = -1;
            else if(gameEnded(board) == 1)
                started = -2;
        }

			if( !(PIND & (1 << PD6)) )  {
				lcd_clear();
				started = 1;
				draw();
			}
			if( !(PINA & (1 << PA4))) {	
				lcd_clear();			
				moveLeft(board);
				draw();
			}
			if( !(PINA & (1 << PA7))) {	
				lcd_clear();
				moveRight(board);
				draw();
			}
			if( !(PINA & (1 << PA5))) {
				lcd_clear();
				moveUp(board);
				draw();
			}
			if( !(PINA & (1 << PA6))) {
				lcd_clear();
				moveDown(board);
				draw();
			}

	}
	lcd_clear();
}
